'use strict';

exports.__esModule = true;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

exports.default = parseGraphqlHTTP;

var _expressGraphql = require('express-graphql');

var _expressGraphql2 = _interopRequireDefault(_expressGraphql);

var _schema = require('@parse-graphql/schema');

var _schema2 = _interopRequireDefault(_schema);

var _getSessionToken = require('./getSessionToken');

var _getSessionToken2 = _interopRequireDefault(_getSessionToken);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getSchema = function () {
  var schema = void 0;
  return function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(options, alwaysRecreate) {
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(!schema || alwaysRecreate)) {
                _context.next = 4;
                break;
              }

              _context.next = 3;
              return (0, _schema2.default)(options);

            case 3:
              schema = _context.sent;

            case 4:
              return _context.abrupt('return', schema);

            case 5:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, undefined);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();
}();

function parseGraphqlHTTP(options) {
  var _this = this;

  var graphiql = options.graphiql,
      parseSchema = options.parseSchema,
      dynamicSchema = options.dynamicSchema;


  if (parseSchema && dynamicSchema) {
    console.warn('Possible undesired behavior: ' + 'parseSchema is set and dynamicSchema is true. Schema will not be dynamic.');
  }

  return (0, _expressGraphql2.default)(function () {
    var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(request) {
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.t0 = graphiql;
              _context2.next = 3;
              return getSchema(options, dynamicSchema);

            case 3:
              _context2.t1 = _context2.sent;
              _context2.t2 = {
                sessionToken: (0, _getSessionToken2.default)(request)
              };
              return _context2.abrupt('return', {
                graphiql: _context2.t0,
                schema: _context2.t1,
                context: _context2.t2
              });

            case 6:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, _this);
    }));

    return function (_x3) {
      return _ref2.apply(this, arguments);
    };
  }());
}
module.exports = exports['default'];